&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : 
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
DEFINE TEMP-TABLE ttSalesRepPerformance NO-UNDO RCODE-INFORMATION 
  FIELD SalesRep    LIKE SalesRep.SalesRep
  FIELD RepName     LIKE SalesRep.RepName
  FIELD YEAR        AS INTEGER FORMAT "9999" LABEL "Financial Year"
  FIELD AnnualQuota AS DECIMAL FORMAT ">>>,>>>,>>9.99" LABEL "Annual Quota"
  FIELD TotalSales  AS DECIMAL FORMAT ">>>,>>>,>>9.99" LABEL "Total Sales"
  FIELD Percentage  AS DECIMAL FORMAT ">,>>>,>>9.99"       LABEL "Percent Achieved"
  INDEX idx1 IS PRIMARY IS UNIQUE SalesRep YEAR.

DEFINE TEMP-TABLE ttItemOrderValue NO-UNDO RCODE-INFORMATION 
  FIELD ItemNum       LIKE ITEM.itemnum
  FIELD ItemName      LIKE ITEM.itemname
  FIELD OrderQuantity AS INTEGER FORMAT ">>>,>>>,>>9" LABEL "Quantity"
  FIELD OrderValue    AS DECIMAL FORMAT ">>>,>>>,>>9.99" LABEL "Total Value"
  INDEX idx1 IS PRIMARY IS UNIQUE ItemNum.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-ItemOrderValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD ItemOrderValue Procedure 
FUNCTION ItemOrderValue RETURNS HANDLE
  ( INPUT FromOrderDate AS DATE,
    INPUT ToOrderDate AS DATE )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-OrderValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD OrderValue Procedure 
FUNCTION OrderValue RETURNS DECIMAL (INPUT icusNum AS INTEGER) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-SalesRepPerformance) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD SalesRepPerformance Procedure 
FUNCTION SalesRepPerformance RETURNS HANDLE
  ( INPUT iStartYear AS INTEGER,
    INPUT iEndYear   AS INTEGER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-SupplierItemOrderValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD SupplierItemOrderValue Procedure 
FUNCTION SupplierItemOrderValue RETURNS HANDLE
  ( INPUT ipSupplierNum AS INTEGER)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-ItemOrderValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION ItemOrderValue Procedure 
FUNCTION ItemOrderValue RETURNS HANDLE
  ( INPUT FromOrderDate AS DATE,
    INPUT ToOrderDate AS DATE ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  EMPTY TEMP-TABLE ttItemOrderValue.
  FOR EACH Order WHERE OrderDate >= FromOrderDate
                   AND OrderDate <= ToOrderDate NO-LOCK:
    FOR EACH OrderLine OF Order NO-LOCK:
      FIND ttItemOrderValue WHERE ttItemOrderValue.ItemNum = OrderLine.ItemNum NO-LOCK NO-ERROR.
      IF NOT AVAILABLE ttItemOrderValue THEN DO:
        CREATE ttItemOrderValue.
        FIND ITEM OF OrderLine NO-LOCK NO-ERROR.
        ASSIGN ttItemOrderValue.ItemNum = OrderLine.ItemNum.
        IF AVAILABLE ITEM THEN DO:
          ttItemOrderValue.ItemName = ITEM.itemname.
        END.
      END.
      ASSIGN ttItemOrderValue.OrderQuantity = ttItemOrderValue.OrderQuantity + OrderLine.Qty
             ttItemOrderValue.OrderValue    = ttItemOrderValue.OrderValue + OrderLine.ExtendedPrice.
    END.
  END.
  RETURN TEMP-TABLE ttItemOrderValue:HANDLE.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-OrderValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION OrderValue Procedure 
FUNCTION OrderValue RETURNS DECIMAL (INPUT icusNum AS INTEGER):
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE dOrderValue AS DECIMAL     NO-UNDO INITIAL 0.
  
  FOR EACH order WHERE order.custnum = iCusnum NO-LOCK,
      EACH orderline OF order NO-LOCK:
      dOrderValue = dOrderValue + extendedprice.
  END.
  RETURN dOrderValue.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-SalesRepPerformance) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION SalesRepPerformance Procedure 
FUNCTION SalesRepPerformance RETURNS HANDLE
  ( INPUT iStartYear AS INTEGER,
    INPUT iEndYear   AS INTEGER ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE iYear      AS INTEGER     NO-UNDO.

  EMPTY TEMP-TABLE ttSalesRepPerformance.

  REPEAT WITH iYear = iStartYear TO iEndYear:
    /* Create records from salesrep */
    FOR EACH SalesRep NO-LOCK:
      CREATE ttSalesRepPerformance.
      ASSIGN 
        ttSalesRepPerformance.SalesRep = SalesRep.SalesRep
        ttSalesRepPerformance.RepName  = SalesRep.RepName
        ttSalesRepPerformance.YEAR     = iYear
        ttSalesRepPerformance.AnnualQuota = SalesRep.MonthQuota[1]
                                          + SalesRep.MonthQuota[2]
                                          + SalesRep.MonthQuota[3]
                                          + SalesRep.MonthQuota[4]
                                          + SalesRep.MonthQuota[5]
                                          + SalesRep.MonthQuota[6]
                                          + SalesRep.MonthQuota[7]
                                          + SalesRep.MonthQuota[8]
                                          + SalesRep.MonthQuota[9]
                                          + SalesRep.MonthQuota[10]
                                          + SalesRep.MonthQuota[11]
                                          + SalesRep.MonthQuota[12].
    END.
  
    /* Add up order value */
    FOR EACH Order WHERE Order.OrderDate >= DATE(1,1,iYear)
                     AND Order.OrderDate <= DATE(12,31,iYear)
                     NO-LOCK:
      FIND ttSalesRepPerformance 
        WHERE ttSalesRepPerformance.SalesRep = Order.SalesRep
          AND ttSalesRepPerformance.YEAR     = iYear NO-ERROR.
      IF AVAILABLE ttSalesRepPerformance THEN DO:
        FOR EACH OrderLine OF Order NO-LOCK:
           ttSalesRepPerformance.TotalSales = ttSalesRepPerformance.TotalSales + OrderLine.ExtendedPrice.
        END.
      END.
    END.
  
    /* Work out percentage */
    FOR EACH ttSalesRepPerformance:
      IF ttSalesRepPerformance.TotalSales = 0 
      THEN ttSalesRepPerformance.Percentage = 0.
      ELSE ttSalesRepPerformance.Percentage = (ttSalesRepPerformance.TotalSales / ttSalesRepPerformance.AnnualQuota).
    END.
  END.

  RETURN TEMP-TABLE ttSalesRepPerformance:HANDLE.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-SupplierItemOrderValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION SupplierItemOrderValue Procedure 
FUNCTION SupplierItemOrderValue RETURNS HANDLE
  ( INPUT ipSupplierNum AS INTEGER) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  EMPTY TEMP-TABLE ttItemOrderValue.
  
  FIND Supplier WHERE Supplier.SupplierID = ipSupplierNum NO-LOCK NO-ERROR.
  
  IF AVAILABLE Supplier THEN DO:
    FOR EACH SupplierItemXref
    WHERE Supplieritemxref.SupplierIDNum = Supplier.SupplierID 
    NO-LOCK:
      FIND ITEM OF SupplierItemXref NO-LOCK NO-ERROR.
      IF AVAILABLE ITEM THEN DO:
        CREATE ttItemOrderValue.
        BUFFER-COPY ITEM TO ttItemOrderValue.
        FOR EACH OrderLine WHERE OrderLine.ItemNum = ITEM.ItemNum NO-LOCK:
          ASSIGN ttItemOrderValue.OrderQuantity = ttItemOrderValue.OrderQuantity + OrderLine.Qty
                 ttItemOrderValue.OrderValue    = ttItemOrderValue.OrderValue + OrderLine.ExtendedPrice.
        END.
      END.
    END.
  END.

  RETURN TEMP-TABLE ttItemOrderValue:HANDLE.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

